﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;

namespace LockCollection
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Thread> threads = new List<Thread>();
            List<int> numbers = new List<int>(10000000);
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Random rand = new Random();
            for (int i = 0; i < 100; i++)
            {
                var thread = new Thread(() =>
                {
                    for (int l = 0; l < 100000; l++)
                       lock (numbers) //comment this and mesure time 
                        {
                            numbers.Add(rand.Next());
                        }
                });
                threads.Add(thread);
                thread.Start();
            }
            foreach (var th in threads)
            {
                th.Join();
            }
            sw.Stop();
            Console.WriteLine($"The number of items in a regular list: {numbers.Count}");
            Console.WriteLine($"Elapsed {sw.ElapsedMilliseconds} ms");
            Console.ReadLine();
        }
    }
}
