﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;
namespace NonUniqueBag
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Thread> threads = new List<Thread>();
            ConcurrentBag<int> numbers = new ConcurrentBag<int>();
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Random rand = new Random();
            for (int i = 0; i < 100; i++)
            {
                var thread = new Thread(() =>
                {

                    for (int l = 0; l < 100; l++)
                    //lock (numbers) //without this, cb has non unique numbers
                    {
                        int number = rand.Next(10001);
                        while (numbers.Any(x => x == number))
                        {
                            number = rand.Next(10001);
                        };
                        numbers.Add(number);
                    }
                });
                threads.Add(thread);
                thread.Start();
            }
            foreach (var watek in threads)
            {
                watek.Join();
            }
            sw.Stop();

            Console.WriteLine($"Elapsed {sw.ElapsedMilliseconds} ms");
            if (numbers.IsUnique()) //using extension method for CB
                Console.WriteLine("All numbers are unique");
            else
                Console.WriteLine("Not all numbers are unique");
        }
    }
}
