﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Threading;

namespace ProducerConsumerQ2
{
    class Program
    {
        static void Main(string[] args)
        {
            var cq = new ConcurrentQueue<int>();
            List<Thread> consumers = new List<Thread>();

            //the producer puts 100 elements into the collection at random intervals of up to 500ms
            var producer = new Thread(() =>
            {
                Random rand = new Random(Thread.CurrentThread.ManagedThreadId);
                for (int l = 0; l < 100; l++)
                {
                    Console.WriteLine($"Put  {l}");
                    cq.Enqueue(l);
                    Thread.Sleep(rand.Next(500));
                }
            });
            producer.Start();
            //      Thread.Sleep(5000); 
            //Consumers take data from the collection at intervals of up to 5000 ms
            for (int i = 0; i < 10; i++)
            {
                var consumer = new Thread(() =>
                {
                    Random rand = new Random(Thread.CurrentThread.ManagedThreadId);
                    for (int l = 0; l < 10; l++)
                    {
                        Thread.Sleep(rand.Next(4000));
                        int result;
                        bool succeeded = cq.TryDequeue(out result);
                        if (!succeeded) 
                            { 
                            l--; 
                            Console.WriteLine("I don't have this time"); 
                            continue;   //continue for
                            }
                        Console.WriteLine($"Take {result} ");
                    }
                });
                consumers.Add(consumer);
                consumer.Start();
            }
            foreach (var th in consumers)
            {
                th.Join();
            }
            producer.Join();
            Console.WriteLine("That's all. Press Enter to finish");
            Console.ReadLine();
        }
    }
}
