﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;

namespace UniqueCollection
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Thread> threads = new List<Thread>();
            List<int> numbers = new List<int>(1000000);
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Random rand = new Random();
            for (int i = 0; i < 100; i++)
            {
                var watek = new Thread(() =>
                {

                    for (int l = 0; l < 100; l++)
                        lock (numbers)
                        {
                            int number = rand.Next(10001);
                            //lock (numbers) //when we use this lock and the one below instead of the above, the numbers will not be unique. 
                            while (numbers.Any(x => x == number))
                            {
                                number = rand.Next(10001);
                            };
                            //lock (numbers) //this lock and the above are just so that there are no errors like "collection was modified" 
                            numbers.Add(number);
                        }
                });
                threads.Add(watek);
                watek.Start();
            }
            foreach (var th in threads)
            {
                th.Join();
            }
            sw.Stop();
            Console.WriteLine($"The number of items in a regular list: {numbers.Count}");
            Console.WriteLine($"Elapsed {sw.ElapsedMilliseconds} ms");
            if (numbers.IsUnique()) //using the extension method for an int list
                Console.WriteLine("All numbers are unique");
            else
                Console.WriteLine("Not all numbers are unique");
        }
    }
}
