﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace UniqueDictionary
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Thread> threads = new List<Thread>();
            ConcurrentDictionary<int, object> numbers = new ConcurrentDictionary<int, object>();
            Stopwatch sw = new Stopwatch();
            sw.Start();
          //  Random rand = new Random(); //BEAWARE OF Random it is not thread safe!!! Sometimes it always returns 0!
            
            for (int i = 0; i < 100; i++)
            {
                var thread = new Thread(() =>
                {
                    Random rand = new Random(Thread.CurrentThread.ManagedThreadId);
                    for (int l = 0; l < 100; l++)
                    {
                        int number = rand.Next(10001);
                        while (!numbers.TryAdd(number, null)) //we use key like a value and value set null
                        {
                            number = rand.Next(10001);
                        };
                    }
                });
                threads.Add(thread);
                thread.Start();
            }
            foreach (var th in threads)
            {
                th.Join();
            }
            sw.Stop();

            Console.WriteLine($"Elapsed {sw.ElapsedMilliseconds} ms");
            Console.WriteLine($"There is {numbers.Count()} numbers in dictionary");
            if (numbers.IsUnique()) //using extension method for dictionary, but they must be unique :)
                Console.WriteLine("All numbers are unique");
            else
                Console.WriteLine("Not all numbers are unique");
            Console.ReadLine();
        }
    }
}
